/*************************************************************/
/* Copyright (C) 2016 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED.
 * THIS COPYRIGHT STATEMENT MAY NOT BE REMOVED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: cam */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.Libitscam_asn1 */
/* Created: Tue Jul 26 13:52:24 2016 */
/* ASN.1 Compiler for Java version: 6.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsCam_asn1 -nolistingfile
 * -nomodlistingfile -constraints -nouserconstraints -valuerefs -debug
 * -nopedantic -noinformatorymessages -uper -root -keepnames -norelaySafe
 * -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-2016.07.26.13.51.38.669/oss6709575508052733262gen/LibItsCam_asn1.gen
 * asn/ITS-Container.asn asn/CAM.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.cam_pdu_descriptions;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type CamParameters from ASN1 Module CAM_PDU_Descriptions.
 * @see Sequence
 */

public class CamParameters extends Sequence {
    
    /**
     * The default constructor.
     */
    public CamParameters()
    {
    }
    
    /**
     * Construct with AbstractData components.
     */
    public CamParameters(BasicContainer basicContainer, 
		    HighFrequencyContainer highFrequencyContainer, 
		    LowFrequencyContainer lowFrequencyContainer, 
		    SpecialVehicleContainer specialVehicleContainer)
    {
	setBasicContainer(basicContainer);
	setHighFrequencyContainer(highFrequencyContainer);
	setLowFrequencyContainer(lowFrequencyContainer);
	setSpecialVehicleContainer(specialVehicleContainer);
    }
    
    /**
     * Construct with required components.
     */
    public CamParameters(BasicContainer basicContainer, 
		    HighFrequencyContainer highFrequencyContainer)
    {
	setBasicContainer(basicContainer);
	setHighFrequencyContainer(highFrequencyContainer);
    }
    
    public void initComponents()
    {
	mComponents[0] = new BasicContainer();
	mComponents[1] = new HighFrequencyContainer();
	mComponents[2] = new LowFrequencyContainer();
	mComponents[3] = new SpecialVehicleContainer();
    }
    
    // Instance initializer
    {
	mComponents = new AbstractData[4];
    }
    
    // Method to create a specific component instance
    public AbstractData createInstance(int index)
    {
	switch (index) {
	    case 0:
		return new BasicContainer();
	    case 1:
		return new HighFrequencyContainer();
	    case 2:
		return new LowFrequencyContainer();
	    case 3:
		return new SpecialVehicleContainer();
	    default:
		throw new InternalError("AbstractCollection.createInstance()");
	}
	
    }
    
    
    // Methods for field "basicContainer"
    public BasicContainer getBasicContainer()
    {
	return (BasicContainer)mComponents[0];
    }
    
    public void setBasicContainer(BasicContainer basicContainer)
    {
	mComponents[0] = basicContainer;
    }
    
    
    // Methods for field "highFrequencyContainer"
    public HighFrequencyContainer getHighFrequencyContainer()
    {
	return (HighFrequencyContainer)mComponents[1];
    }
    
    public void setHighFrequencyContainer(HighFrequencyContainer highFrequencyContainer)
    {
	mComponents[1] = highFrequencyContainer;
    }
    
    
    // Methods for field "lowFrequencyContainer"
    public LowFrequencyContainer getLowFrequencyContainer()
    {
	return (LowFrequencyContainer)mComponents[2];
    }
    
    public void setLowFrequencyContainer(LowFrequencyContainer lowFrequencyContainer)
    {
	mComponents[2] = lowFrequencyContainer;
    }
    
    public boolean hasLowFrequencyContainer()
    {
	return componentIsPresent(2);
    }
    
    public void deleteLowFrequencyContainer()
    {
	setComponentAbsent(2);
    }
    
    
    // Methods for field "specialVehicleContainer"
    public SpecialVehicleContainer getSpecialVehicleContainer()
    {
	return (SpecialVehicleContainer)mComponents[3];
    }
    
    public void setSpecialVehicleContainer(SpecialVehicleContainer specialVehicleContainer)
    {
	mComponents[3] = specialVehicleContainer;
    }
    
    public boolean hasSpecialVehicleContainer()
    {
	return componentIsPresent(3);
    }
    
    public void deleteSpecialVehicleContainer()
    {
	setComponentAbsent(3);
    }
    
    
    /**
     * Initialize the type descriptor.
     */
    private static final SequenceInfo c_typeinfo = new SequenceInfo (
	new Tags (
	    new short[] {
		0x0010
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.cam_pdu_descriptions",
	    "CamParameters"
	),
	new QName (
	    "CAM-PDU-Descriptions",
	    "CamParameters"
	),
	274462,
	null,
	new Fields (
	    new SequenceFieldInfo[] {
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8000
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.cam_pdu_descriptions",
				"BasicContainer"
			    ),
			    new QName (
				"CAM-PDU-Descriptions",
				"BasicContainer"
			    ),
			    274462,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.cam_pdu_descriptions",
				    "BasicContainer"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.cam_pdu_descriptions",
				    "BasicContainer"
				)
			    ),
			    0
			)
		    ),
		    "basicContainer",
		    0,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new ChoiceInfo (
			    new Tags (
				new short[] {
				    (short)0x8001
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.cam_pdu_descriptions",
				"HighFrequencyContainer"
			    ),
			    new QName (
				"CAM-PDU-Descriptions",
				"HighFrequencyContainer"
			    ),
			    274462,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.cam_pdu_descriptions",
				    "HighFrequencyContainer"
				)
			    ),
			    0,
			    new TagDecoder (
				new TagDecoderElement[] {
				    new TagDecoderElement((short)0x8000, 0),
				    new TagDecoderElement((short)0x8001, 1)
				}
			    )
			)
		    ),
		    "highFrequencyContainer",
		    1,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new ChoiceInfo (
			    new Tags (
				new short[] {
				    (short)0x8002
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.cam_pdu_descriptions",
				"LowFrequencyContainer"
			    ),
			    new QName (
				"CAM-PDU-Descriptions",
				"LowFrequencyContainer"
			    ),
			    274462,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.cam_pdu_descriptions",
				    "LowFrequencyContainer"
				)
			    ),
			    0,
			    new TagDecoder (
				new TagDecoderElement[] {
				    new TagDecoderElement((short)0x8000, 0)
				}
			    )
			)
		    ),
		    "lowFrequencyContainer",
		    2,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new ChoiceInfo (
			    new Tags (
				new short[] {
				    (short)0x8003
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.cam_pdu_descriptions",
				"SpecialVehicleContainer"
			    ),
			    new QName (
				"CAM-PDU-Descriptions",
				"SpecialVehicleContainer"
			    ),
			    274462,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.cam_pdu_descriptions",
				    "SpecialVehicleContainer"
				)
			    ),
			    0,
			    new TagDecoder (
				new TagDecoderElement[] {
				    new TagDecoderElement((short)0x8000, 0),
				    new TagDecoderElement((short)0x8001, 1),
				    new TagDecoderElement((short)0x8002, 2),
				    new TagDecoderElement((short)0x8003, 3),
				    new TagDecoderElement((short)0x8004, 4),
				    new TagDecoderElement((short)0x8005, 5),
				    new TagDecoderElement((short)0x8006, 6)
				}
			    )
			)
		    ),
		    "specialVehicleContainer",
		    3,
		    3,
		    null
		)
	    }
	),
	0,
	new TagDecoders (
	    new TagDecoder[] {
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8000, 0)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8001, 1)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8002, 2),
			new TagDecoderElement((short)0x8003, 3)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8003, 3)
		    }
		)
	    }
	),
	0
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' CamParameters object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' CamParameters object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for CamParameters
